## mozjs115 115.1.0

=== debian/changelog ===
mozjs115 (115.1.0-0ubuntu1) mantic; urgency=medium

  * Upload to Ubuntu while waiting for Debian NEW processing

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 22 Aug 2023 14:47:47 -0400

mozjs115 (115.1.0-1) UNRELEASED; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release

  [ Marco Trevisan (Treviño) ]
  * debian/patches: Refresh
  * debian/autogen.sh: Do not run autoreconf on old-configure
  * debian/control: Remove build dependency on autoconf2.13
  * debian/gbp-repack-mozjs-source.sh: Do not export AUTOCONF variable
  * debian/control: Update VCS references to 115 branch
  * debian/rules: Remove commented mozjs configure removal
  * debian/libmozjs-115.0.docs: Install README and remove removed files

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Tue, 22 Aug 2023 19:30:18 +0200

mozjs102 (102.14.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2023-4046: Incorrect value used during WASM compilation

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 03 Aug 2023 11:29:17 -0400

mozjs102 (102.13.0-1) unstable; urgency=high

  * New upstream release (LP: #2026197)
    - CVE-2023-37202: Potential use-after-free from compartment mismatch
      in SpiderMonkey
    - CVE-2023-37211: Memory safety bugs

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 05 Jul 2023 09:05:35 -0400

mozjs102 (102.12.0-1) unstable; urgency=high

  * New upstream release (LP: #2023047) (Closes: #1037158)
    - CVE-2023-34416: Memory safety bugs
  * Update debian/upstream/signing-key.asc per upstream rotation

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 06 Jun 2023 11:20:22 -0400

mozjs102 (102.11.0-1) unstable; urgency=high

  * New upstream release (LP: #2018905)
    - CVE-2023-32205: Browser prompts could have been obscured by popups
    - CVE-2023-32206: Crash in RLBox Expat driver
    - CVE-2023-32207: Potential permissions request bypass via clickjacking
    - CVE-2023-32211: Content process crash due to invalid wasm code
    - CVE-2023-32212: Potential spoof due to obscured address bar
    - CVE-2023-32213: Potential memory corruption in FileReader::DoReadData()
    - CVE-2023-32214: Potential DoS via exposed protocol handlers
    - CVE-2023-32215: Memory safety bugs

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 08 May 2023 11:59:12 -0400

mozjs102 (102.10.0-1) unstable; urgency=high

  * New upstream release (LP: #2015880)
    - CVE-2023-29536: Invalid free from JavaScript code
    - CVE-2023-29548: Incorrect optimization result on ARM64
    - CVE-2023-29550: Memory safety bugs
    - CVE-2023-29535: Potential Memory Corruption following Garbage Collector
      compaction

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 10 Apr 2023 19:48:42 -0400

mozjs102 (102.9.0-1) unstable; urgency=high

  [ Jeremy Bicha ]
  * New upstream release
    - CVE-2023-25751: Incorrect code generation during JIT compilation

  [ John Paul Adrian Glaubitz ]
  * Disable large-arraybuffers/base.js on all big-endian targets
    (Closes: #1020700)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 13 Mar 2023 11:03:53 -0400

mozjs102 (102.8.0-1) unstable; urgency=medium

  * New upstream release
  * Drop Python 3.11 patch: applied in new release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 15 Feb 2023 08:57:21 -0500

mozjs102 (102.7.0-1) unstable; urgency=medium

  * New upstream release
  * Cherry-pick patch to fix build with Python 3.11 (Closes: #1028716)
  * Re-export upstream signing key without extra signatures
  * Update standards version to 4.6.2, no changes needed

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 17 Jan 2023 15:57:16 -0500

mozjs102 (102.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 12 Dec 2022 17:16:33 -0500

mozjs102 (102.5.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 15 Nov 2022 12:28:41 -0500

mozjs102 (102.4.0-1) unstable; urgency=medium

  * New upstream release
  * Drop ARMv7 atomic operations patch: applied in new release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 17 Oct 2022 14:03:07 -0400

mozjs102 (102.3.0-1) unstable; urgency=medium

  * Team upload

  [ Jeremy Bicha ]
  * New upstream release

  [ Simon McVittie ]
  * d/p/jit-Only-use-ARMv7-atomic-operations-on-ARMv7-or-higher.patch:
  * Add patch to avoid using ARMv7 atomic operations on armel
  * d/p/js-Enable-JIT-by-default-on-ARMv7-or-up-but-not-ARMv6-or-.patch:
    Attempt to solve FTBFS on armel by disabling JIT
  * Update Lintian overrides
  * d/copyright: Remove patterns that no longer match anything
  * Standards-Version: 4.6.1 (no changes required)

  [ Adrian Bunk ]
  * d/p/js-arm-i386-no-simd.patch:
    Avoid SIMD (SSE/NEON) on 32-bit ARM and x86. It is not in the baseline
    of our i386/armel/armhf ports.
  * d/rules: Build with -Wl,--allow-multiple-definition on armel
    (works around mozjs102's equivalent of mozjs91 bug #1017979)
  * Go back to using the default gcc on armel (Closes: #1018047)
  * Exclude basic/bug-1649234-1.js test on armel (Closes: #1017961)

 -- Simon McVittie <smcv@debian.org>  Sat, 24 Sep 2022 20:53:33 +0100

mozjs102 (102.2.0-2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/rules: Pre-create debian/build/dist/cppunittests/ as a directory
  * d/test.sh: Explicitly mark js executable as executable
  * Build using gcc-11 on armel
    (works around mozjs102's equivalent of mozjs91 bug #1017979)
  * Add patch to avoid "impossible constraints" on armhf (Closes: #1017962)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 24 Aug 2022 11:39:02 -0400

mozjs102 (102.2.0-1) unstable; urgency=medium

  [ Jeremy Bicha ]
  * New upstream release
  * Drop 2 cherry-picked patches applied in new release

  [ Mike Homney ]
  * Add patch to remove workaround for old libstdc++ problem,
    which now causes problems with GCC 12 on arm

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 22 Aug 2022 11:55:51 -0400

mozjs102 (102.1.0-2) unstable; urgency=medium

  * Rebuild after NEW acceptance



## mozjs115 115.2.0

=== debian/changelog ===
mozjs115 (115.2.0-0ubuntu1) mantic; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 01 Sep 2023 15:41:07 -0400

## mozjs115 115.10.0

=== third_party/python/aiohttp/Makefile ===
# Some simple testing tasks (sorry, UNIX only).

to-hash-one = $(dir $1).hash/$(addsuffix .hash,$(notdir $1))
to-hash = $(foreach fname,$1,$(call to-hash-one,$(fname)))

CYS := $(wildcard aiohttp/*.pyx) $(wildcard aiohttp/*.pyi)  $(wildcard aiohttp/*.pxd)
PYXS := $(wildcard aiohttp/*.pyx)
CS := $(wildcard aiohttp/*.c)
PYS := $(wildcard aiohttp/*.py)
REQS := $(wildcard requirements/*.txt)
ALLS := $(sort $(CYS) $(CS) $(PYS) $(REQS))

.PHONY: all
all: test

tst:
	@echo $(call to-hash,requirements/cython.txt)
	@echo $(call to-hash,aiohttp/%.pyx)


# Recipe from https://www.cmcrossroads.com/article/rebuilding-when-files-checksum-changes
FORCE:

# check_sum.py works perfectly fine but slow when called for every file from $(ALLS)
# (perhaps even several times for each file).
# That is why much less readable but faster solution exists
ifneq (, $(shell which sha256sum))
%.hash: FORCE
	$(eval $@_ABS := $(abspath $@))
	$(eval $@_NAME := $($@_ABS))
	$(eval $@_HASHDIR := $(dir $($@_ABS)))
	$(eval $@_TMP := $($@_HASHDIR)../$(notdir $($@_ABS)))
	$(eval $@_ORIG := $(subst /.hash/../,/,$(basename $($@_TMP))))
	@#echo ==== $($@_ABS) $($@_HASHDIR) $($@_NAME) $($@_TMP) $($@_ORIG)
	@if ! (sha256sum --check $($@_ABS) 1>/dev/null 2>/dev/null); then \
	  mkdir -p $($@_HASHDIR); \
	  echo re-hash $($@_ORIG); \
	  sha256sum $($@_ORIG) > $($@_ABS); \
	fi
else
%.hash: FORCE
	@./tools/check_sum.py $@ # --debug
endif

# Enumerate intermediate files to don't remove them automatically.
.SECONDARY: $(call to-hash,$(ALLS))


.install-cython: $(call to-hash,requirements/cython.txt)
	pip install -r requirements/cython.txt
	@touch .install-cython

aiohttp/_find_header.c: $(call to-hash,aiohttp/hdrs.py ./tools/gen.py)
	./tools/gen.py

# _find_headers generator creates _headers.pyi as well
aiohttp/%.c: aiohttp/%.pyx $(call to-hash,$(CYS)) aiohttp/_find_header.c
	cython -3 -o $@ $< -I aiohttp


.PHONY: cythonize
cythonize: .install-cython $(PYXS:.pyx=.c)

.install-deps: .install-cython $(PYXS:.pyx=.c) $(call to-hash,$(CYS) $(REQS))
	pip install -r requirements/dev.txt
	@touch .install-deps

.PHONY: lint
lint: fmt mypy

.PHONY: fmt format
fmt format:
	python -m pre_commit run --all-files --show-diff-on-failure

.PHONY: mypy
mypy:
	mypy aiohttp

.develop: .install-deps $(call to-hash,$(PYS) $(CYS) $(CS))
	pip install -e .
	@touch .develop

.PHONY: test
test: .develop
	@pytest -q

.PHONY: vtest
vtest: .develop
	@pytest -s -v

.PHONY: vvtest
vvtest: .develop
	@pytest -vv

.PHONY: clean
clean:
	@rm -rf `find . -name __pycache__`
	@rm -rf `find . -name .hash`
	@rm -rf `find . -name .md5`  # old styling
	@rm -f `find . -type f -name '*.py[co]' `
	@rm -f `find . -type f -name '*~' `
	@rm -f `find . -type f -name '.*~' `
	@rm -f `find . -type f -name '@*' `
	@rm -f `find . -type f -name '#*#' `
	@rm -f `find . -type f -name '*.orig' `
	@rm -f `find . -type f -name '*.rej' `
	@rm -f `find . -type f -name '*.md5' `  # old styling
	@rm -f .coverage
	@rm -rf htmlcov
	@rm -rf build
	@rm -rf cover
	@make -C docs clean
	@python setup.py clean
	@rm -f aiohttp/*.so
	@rm -f aiohttp/*.pyd
	@rm -f aiohttp/*.html
	@rm -f aiohttp/_frozenlist.c
	@rm -f aiohttp/_find_header.c
	@rm -f aiohttp/_http_parser.c
	@rm -f aiohttp/_http_writer.c
	@rm -f aiohttp/_websocket.c
	@rm -rf .tox
	@rm -f .develop
	@rm -f .flake
	@rm -rf aiohttp.egg-info
	@rm -f .install-deps
	@rm -f .install-cython

.PHONY: doc
doc:
	@make -C docs html SPHINXOPTS="-W --keep-going -E"
	@echo "open file://`pwd`/docs/_build/html/index.html"

.PHONY: doc-spelling
doc-spelling:
	@make -C docs spelling SPHINXOPTS="-W -E"

.PHONY: install
install:
	@pip install -U 'pip'
	@pip install -Ur requirements/dev.txt

.PHONY: install-dev
install-dev: .develop

=== third_party/rust/authenticator/webdriver-tools/requirements.txt ===
requests>=2.23.0
rich>=3.0

=== testing/web-platform/tests/tools/wptrunner/requirements.txt ===
html5lib==1.1
mozdebug==0.3.0
mozinfo==1.2.2  # https://bugzilla.mozilla.org/show_bug.cgi?id=1621226
mozlog==7.1.1
mozprocess==1.3.0
packaging==23.1
pillow==9.5.0
requests==2.30.0
six==1.16.0
urllib3==1.26.15
aioquic==0.9.19

=== third_party/rust/cubeb-sys/libcubeb/cmake/sanitizers-cmake/CMakeLists.txt ===
# This file is part of CMake-sanitizers.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
# Copyright (c)
#   2013-2015 Matt Arsenault
#   2015      RWTH Aachen University, Federal Republic of Germany
#


#
# project information
#

# minimum required cmake version
cmake_minimum_required(VERSION 2.8)

# project name
project("CMake-sanitizers")



#
# cmake configuration
#
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})



#
# add tests
#
enable_testing()
add_subdirectory(tests)

## mozjs115 115.3.0

=== debian/changelog ===
mozjs115 (115.3.0-0ubuntu1) mantic; urgency=medium

  * New upstream release
    - CVE-2023-5171: Use-after-free in Ion Compiler

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 26 Sep 2023 12:44:50 -0400

=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to debian/control.in instead.
# This file is regenerated automatically in the clean target.
Source: mozjs115
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@debian.org>, Jeremy Bícha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               gnome-pkg-tools,
               cargo,
               clang,
               autoconf,
               automake,
               libreadline-dev,
               llvm,
               zlib1g-dev (>= 1:1.2.3),
               pkg-config,
               pkg-kde-tools,
               python3-dev,
               rustc (>= 1.41),
               tzdata,
               zip
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/gnome-team/mozjs/tree/debian/115/master
Vcs-Git: https://salsa.debian.org/gnome-team/mozjs.git -b debian/115/master
Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey

Package: libmozjs-115-0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, tzdata
Description: SpiderMonkey JavaScript library
 SpiderMonkey is the code-name for Mozilla Firefox's C++ implementation of
 JavaScript. It is intended to be embedded in other applications
 that provide host environments for JavaScript.
 .
 This library is intended for use in contexts where only trusted
 JavaScript code will be run, such as GNOME's gjs, Cinnamon's cjs, and
 polkit's rules parsing. It should not be used to run untrusted JavaScript
 from web pages: use a security-supported implementation such as Firefox,
 Chrome or WebKitGTK's JavaScriptCore instead.

Package: libmozjs-115-dev
Architecture: any
Section: libdevel
Depends: libmozjs-115-0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SpiderMonkey JavaScript library - development headers
 SpiderMonkey is the code-name for Mozilla Firefox's C++ implementation of
 JavaScript. It is intended to be embedded in other applications
 that provide host environments for JavaScript.
 .
 This package contains the header files which are
 needed for developing SpiderMonkey embedders.
 .
 This library is intended for use in contexts where only trusted
 JavaScript code will be run, such as GNOME's gjs, Cinnamon's cjs, and
 polkit's rules parsing. It should not be used to run untrusted JavaScript
 from web pages: use a security-supported implementation such as Firefox,
 Chrome or WebKitGTK's JavaScriptCore instead.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk

# Disable CET, until JIT is ported too, preventing accidentally
# building incompatible binaries.
ifeq ($(DEB_HOST_ARCH),amd64)
export DEB_CFLAGS_MAINT_APPEND=-fcf-protection=none
export DEB_CXXFLAGS_MAINT_APPEND=-fcf-protection=none
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This can be disabled if the bundled icu overtakes the system version,
# or for backporting
WITH_SYSTEM_ICU = no

export DEB_HOST_ARCH
# mozjs' build process does not seem to be compatible with other shells
# like zsh
export SHELL = /bin/sh
export PYTHON3 = python3
# Please tell us what you're thinking...
export MOZ_CONFIGURE_TRACE = yes

SRCDIR = $(CURDIR)/js/src
BUILDDIR = $(CURDIR)/debian/build
CARGO_HOME = $(BUILDDIR)/cargo-home
CONFIGURE_FLAGS =
RUSTFLAGS =

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/[-+~].*//')
UPSTREAM_MAJOR = $(shell echo $(UPSTREAM_VERSION) | cut -d. -f1)
UPSTREAM_MINOR = $(shell echo $(UPSTREAM_VERSION) | cut -d. -f2)
UPSTREAM_PATCH = $(shell echo $(UPSTREAM_VERSION) | cut -d. -f3)

export MOZJS_VERSION = $(UPSTREAM_MAJOR)
LIBNAME = libmozjs-$(MOZJS_VERSION)
SONAME = $(LIBNAME).so.0

VERSIONED_LIBNAME = \
	$(LIBNAME).so.$(UPSTREAM_MAJOR).$(UPSTREAM_MINOR).$(UPSTREAM_PATCH)

# ia64 currently has toolchain issues, so relax the link optimization
ifneq (,$(findstring $(DEB_BUILD_ARCH),ia64))
	DEB_CFLAGS_MAINT_APPEND += -G0
	DEB_CXXFLAGS_MAINT_APPEND += -G0
endif

ifneq (,$(findstring $(DEB_BUILD_ARCH),sh4))
        DEB_CFLAGS_MAINT_APPEND += -mlra
        DEB_CXXFLAGS_MAINT_APPEND += -mlra
endif

ifneq (,$(findstring $(DEB_BUILD_ARCH),armel))
        DEB_LDFLAGS_MAINT_APPEND += -Wl,--allow-multiple-definition
        CONFIGURE_FLAGS += --disable-shared-memory
endif

export DEB_CFLAGS_MAINT_APPEND DEB_CXXFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

EXCLUDED_TESTS :=

# Upstream assumes everything uses SSE mathematics, but SSE isn't in
# Debian's baseline for i386, so we are stuck with i387 and its weird
# 80-bit floating point registers. We can't even work around this with
# -fexcess-precision=standard, because mozjs is C++.
# https://bugzilla.mozilla.org/show_bug.cgi?id=1621900
ifneq (,$(findstring $(DEB_BUILD_ARCH),i386))
	EXCLUDED_TESTS += basic/bug653153.js
	EXCLUDED_TESTS += basic/fdlibm-for-sin-cos-tan-argument.js
endif

# See: https://bugzilla.mozilla.org/show_bug.cgi?id=1755540
ifneq (,$(findstring $(DEB_BUILD_ARCH),powerpc ppc64 sparc64 s390x))
	EXCLUDED_TESTS += large-arraybuffers/basic.js
endif

ifneq (,$(findstring $(DEB_BUILD_ARCH),armel))
	EXCLUDED_TESTS += basic/bug-1649234-1.js
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),mips mipsel mips64el))
CONFIGURE_FLAGS += --disable-jit
endif

ifeq ($(DEB_HOST_ARCH),sh4)
        DEB_LDFLAGS_MAINT_APPEND += -no-pie
endif

ifeq ($(WITH_SYSTEM_ICU),yes)
CONFIGURE_FLAGS += --with-system-icu
else
CONFIGURE_FLAGS += --without-system-icu
endif

# See https://github.com/rust-lang/rust/issues/66118
RUSTFLAGS += -Clto=thin

export RUSTFLAGS
export CARGO_HOME

%:
	dh $@ --sourcedirectory=$(SRCDIR) --builddirectory=$(BUILDDIR) --with gnome,pkgkde-symbolshelper

override_dh_clean:
	dh_clean
	find $(CURDIR) -name \*.pyc -exec rm {} \;
	find $(CURDIR)/js/src/ -type l -exec rm {} \;
	rm -f $(CURDIR)/js/src/config/nsinstall
	rm -f $(CURDIR)/js/src/dist/bin/.purgecaches
	rm -f  $(CURDIR)/js/src/js$(MOZJS_VERSION)-config \
		$(CURDIR)/js/src/mozjs-$(MOZJS_VERSION).pc \
		$(CURDIR)/js/src/symverscript
	rm -f $(CURDIR)/js/src/config.log
	rm -fr $(CURDIR)/intl/icu/source/autom4te.cache
	rm -fr $(CURDIR)/debian/build
	rm -rf third_party/python/psutil/build/ third_party/python/psutil/psutil/_*.so third_party/python/psutil/tmp/

override_dh_autoreconf:
	WITH_SYSTEM_ICU=$(WITH_SYSTEM_ICU) dh_autoreconf $(CURDIR)/debian/autogen.sh

# dh_auto_configure does not properly handle autoconf2.13 generated configure
# scripts, so we call configure ourselves.
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=570375
# The bundled copy of icu prefers clang, which we need to override to
# use gcc because clang doesn't support our DEB_CFLAGS_MAINT_APPEND
ifeq ($(origin CC),default)
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif
ifeq ($(origin CXX),default)
CXX := $(DEB_HOST_GNU_TYPE)-g++
endif

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/dist/cppunittests
	cd $(BUILDDIR); \
	if env \
		CC=$(CC) \
		CXX=$(CXX) \
		RUST_HOST=$(DEB_BUILD_RUST_TYPE) \
		RUST_TARGET=$(DEB_HOST_RUST_TYPE) \
	$(SHELL) $(SRCDIR)/configure \
		--host=$(DEB_BUILD_GNU_TYPE) \
		--target=$(DEB_HOST_GNU_TYPE) \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		--with-system-zlib \
		--disable-strip \
		--with-intl-api \
		--enable-readline \
		--disable-jemalloc \
		$(CONFIGURE_FLAGS) \
	; then \
		echo Configure successful; \
	else \
		echo Configure failed with status $$?; \
		tail -v -n +0 config.log; \
		exit 1; \
	fi

execute_before_dh_install:
	# move library and create additional symlinks to standardize the file layout
	cd $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ && \
		mv libjs_static.ajs $(LIBNAME).a && \
		mv $(LIBNAME).so $(VERSIONED_LIBNAME) && \
		ln -s $(VERSIONED_LIBNAME) $(SONAME) && \
		ln -s $(SONAME) $(LIBNAME).so
	rm debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/$(LIBNAME).a

execute_after_dh_fixperms:
	chmod a-x $(CURDIR)/debian/$(LIBNAME)-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/mozjs-$(MOZJS_VERSION).pc

override_dh_gnome:
	dh_gnome --no-gnome-versions

override_dh_auto_test:
	@:
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	SRCDIR=${SRCDIR} BUILDDIR=${BUILDDIR} DEB_HOST_ARCH=${DEB_HOST_ARCH} $(CURDIR)/debian/test.sh $(EXCLUDED_TESTS)
endif
endif

## mozjs115 115.8.0

=== debian/changelog ===
mozjs115 (115.8.0-1) unstable; urgency=medium

  * New upstream release
  * Drop 3 patches applied in new release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 19 Feb 2024 17:36:52 -0500

mozjs115 (115.7.0-4) unstable; urgency=medium

  * Team upload

  [ Simon McVittie ]
  * d/p/python3.12-six.patch:
    Rediff patch so quilt, dpkg-source and gbp pq agree on its effect

  [ Amin Bandali ]
  * Cherry-pick more upstream patches to fix build with Python 3.12
    - debian/patches/python3.12-bug1831512.patch
    - debian/patches/python3.12-bug1857516.patch
    - debian/patches/python3.12-bug1860051.patch
    - debian/patches/python3.12-bug1874280.patch
    - debian/patches/python3.12-bug1851580.patch
    - debian/patches/python3.12-bug1866829.patch

 -- Amin Bandali <bandali@ubuntu.com>  Fri, 16 Feb 2024 11:28:22 -0500

mozjs115 (115.7.0-3) unstable; urgency=medium

  * Team upload
  * d/p/Export-js-detail-CanonicalizedNaNBits-on-architectures-th.patch:
    Add a patch to fix linking of gjs (>= 1.78.3) on mips64el
    (Closes: #1063446)
  * d/tests/dev: Add a superficial autopkgtest.
    In addition to exercising basic compilation and initialization,
    this verifies that #1063446 has been fixed.

 -- Simon McVittie <smcv@debian.org>  Thu, 08 Feb 2024 14:40:52 +0000

mozjs115 (115.7.0-2) unstable; urgency=medium

  * Cherry-pick patch to fix build with Python 3.12

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 24 Jan 2024 08:51:19 -0500

mozjs115 (115.7.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 23 Jan 2024 08:36:55 -0500

mozjs115 (115.6.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2023-6864: Memory safety bug

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 02 Jan 2024 15:48:13 -0500

mozjs115 (115.5.0-1) unstable; urgency=medium

  * New upstream release
  * Stop using debian/control.in and gnome-pkg-tools (no translations here)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 21 Nov 2023 12:43:37 -0500

mozjs115 (115.4.0-2) unstable; urgency=high

  * Add patch to fix the non-JIT armel build
  * Adjust patch to update expected armel failures for 115

 -- Adrian Bunk <bunk@debian.org>  Wed, 25 Oct 2023 19:32:07 -0400

mozjs115 (115.4.0-1) unstable; urgency=medium

  * New upstream release
    - CVE-2023-5728: Improper object tracking during GC could lead to a crash

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 23 Oct 2023 15:44:30 -0400

mozjs115 (115.3.0-1) unstable; urgency=medium

  * New upstream release
  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 26 Sep 2023 12:34:26 -0400

mozjs115 (115.1.0-1) experimental; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release

  [ Marco Trevisan (Treviño) ]
  * debian/patches: Refresh
  * debian/autogen.sh: Do not run autoreconf on old-configure
  * debian/control: Remove build dependency on autoconf2.13
  * debian/gbp-repack-mozjs-source.sh: Do not export AUTOCONF variable
  * debian/control: Update VCS references to 115 branch
  * debian/rules: Remove commented mozjs configure removal
  * debian/libmozjs-115.0.docs: Install README and remove removed files

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Tue, 22 Aug 2023 19:30:18 +0200

mozjs102 (102.15.1-1) unstable; urgency=medium

  * New upstream release
    - This is the final upstream release in the 102 series.
      It's recommended to switch to mozjs115 instead.

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 18 Sep 2023 16:30:07 -0400

mozjs102 (102.15.0-1) unstable; urgency=medium

  * New upstream release
    - This is the final upstream release in the 102 series.
      It's recommended to switch to mozjs115 instead.

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 01 Sep 2023 16:58:48 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,9 @@
-# This file is autogenerated. DO NOT EDIT!
-#
-# Modifications should be made to debian/control.in instead.
-# This file is regenerated automatically in the clean target.
 Source: mozjs115
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Iain Lane <laney@debian.org>, Jeremy Bícha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Jeremy Bícha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: debhelper-compat (= 13),
-               gnome-pkg-tools,
                cargo,
                clang,
                autoconf,

## mozjs115 115.10.0

=== debian/changelog ===
mozjs115 (115.10.0-1) unstable; urgency=high

  * New upstream release (LP: #2061860)
    - CVE-2024-3852: GetBoundName in the JIT returned the wrong object
    - CVE-2024-3854: Out-of-bounds-read after mis-optimized switch statement
    - CVE-2024-3857: Incorrect JITting of arguments led to use-after-free
      during garbage collection

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 16 Apr 2024 07:52:09 -0400

mozjs115 (115.9.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2024-2607: JIT code failed to save return registers on Armv7-A

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 18 Mar 2024 11:47:42 -0400

mozjs115 (115.8.0-3) unstable; urgency=medium

  * Build-depend on dpkg-dev (>= 1.22.5) (Closes: #1065286)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 02 Mar 2024 18:02:34 -0500

mozjs115 (115.8.0-2) unstable; urgency=medium

  * Release to unstable (Closes: #1046520)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 27 Feb 2024 21:59:28 -0500

mozjs115 (115.8.0-2~exp1) experimental; urgency=medium

  [ Steve Langasek ]
  * Rename libraries for 64-bit time_t transition

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 19 Feb 2024 17:39:30 -0500

=== debian/tests/control ===
Tests: dev
Restrictions: allow-stderr, superficial
Depends:
 build-essential,
 libmozjs-115-dev,
 pkgconf,

=== debian/watch ===
# As of August 2020, there is not an official release of SpiderMonkey 78
# The tarball is built using firefox sources, excluding the unneeded files
# as per filtering done in debian/gbp.conf
# Also try
# http://ftp.gnome.org/pub/gnome/teams/releng/tarballs-needing-help/mozjs/
version=4
opts=pgpsigurlmangle=s/$/.asc/,uversionmangle=s/esr$// \
https://ftp.mozilla.org/pub/firefox/releases/\
	(115\.[\d.]+)esr/source/\
	firefox-@ANY_VERSION@\.source\.tar\.xz

## mozjs115 115.11.0

=== debian/changelog ===
mozjs115 (115.11.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 14 May 2024 18:32:36 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
 Uploaders: Jeremy Bícha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: debhelper-compat (= 13),
+               dpkg-dev (>= 1.22.5),
                cargo,
                clang,
                autoconf,
@@ -23,7 +24,10 @@
 Vcs-Git: https://salsa.debian.org/gnome-team/mozjs.git -b debian/115/master
 Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey
 
-Package: libmozjs-115-0
+Package: libmozjs-115-0t64
+Provides: ${t64:Provides}
+Replaces: libmozjs-115-0
+Breaks: libmozjs-115-0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, tzdata
@@ -41,7 +45,7 @@
 Package: libmozjs-115-dev
 Architecture: any
 Section: libdevel
-Depends: libmozjs-115-0 (= ${binary:Version}),
+Depends: libmozjs-115-0t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: SpiderMonkey JavaScript library - development headers

## mozjs115 115.13.0

=== debian/changelog ===
mozjs115 (115.13.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 09 Jul 2024 15:35:34 -0400

mozjs115 (115.12.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2024-5688 Use-after-free in JavaScript object transplant
    - CVE-2024-5700 Memory safety bugs

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 11 Jun 2024 14:34:32 -0400

## mozjs115 115.14.0

=== debian/changelog ===
mozjs115 (115.14.0-0deepin3) unstable; urgency=medium

  * add sw64 support.

 -- lichenggang <lichenggang@deepin.org>  Mon, 25 Aug 2025 15:27:19 +0800

mozjs115 (115.14.0-0deepin2) unstable; urgency=medium

  * revert 64-bit time_t transition patch.

 -- lichenggang <lichenggang@deepin.org>  Fri, 18 Oct 2024 16:45:23 +0800

mozjs115 (115.14.0-0deepin1) unstable; urgency=medium

  * New upstream release
    - CVE-2024-5688 Use-after-free in JavaScript object transplant
    - CVE-2024-5700 Memory safety bugs
    - CVE-2024-7527 Use-after-free in JavaScript garbage collection
    - CVE-2024-7521 Incomplete WebAssembly exception

 -- Tianyu Chen <sweetyfish@deepin.org>  Tue, 24 Sep 2024 17:43:08 +0800

=== debian/control ===
--- 
+++ 
@@ -24,10 +24,7 @@
 Vcs-Git: https://salsa.debian.org/gnome-team/mozjs.git -b debian/115/master
 Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey
 
-Package: libmozjs-115-0t64
-Provides: ${t64:Provides}
-Replaces: libmozjs-115-0
-Breaks: libmozjs-115-0 (<< ${source:Version})
+Package: libmozjs-115-0
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, tzdata
@@ -45,7 +42,7 @@
 Package: libmozjs-115-dev
 Architecture: any
 Section: libdevel
-Depends: libmozjs-115-0t64 (= ${binary:Version}),
+Depends: libmozjs-115-0 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: SpiderMonkey JavaScript library - development headers

=== debian/rules ===
--- 
+++ 
@@ -104,7 +104,7 @@
 export CARGO_HOME
 
 %:
-	dh $@ --sourcedirectory=$(SRCDIR) --builddirectory=$(BUILDDIR) --with gnome,pkgkde-symbolshelper
+	dh $@ --sourcedirectory=$(SRCDIR) --builddirectory=$(BUILDDIR) --with pkgkde-symbolshelper
 
 override_dh_clean:
 	dh_clean

## mozjs115 115.16.0

=== debian/changelog ===
mozjs115 (115.16.0-1) unstable; urgency=high

  * New upstream release (LP: #2083344)
    - CVE-2024-8381 Type confusion when looking up property names
    - CVE-2024-8382 Internal event interfaces exposed to web content
    - CVE-2024-8384 Garbage collection could mis-color cross-compartment objects
    - CVE-2024-9401 Memory safety bugs

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 01 Oct 2024 11:09:34 -0400

mozjs115 (115.14.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2024-7527 Use-after-free in JavaScript garbage collection
    - CVE-2024-7521 Incomplete WebAssembly exception
  * Bump Standards Version to 4.7.0

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 07 Aug 2024 12:28:23 -0400

=== debian/control ===
--- 
+++ 
@@ -12,19 +12,22 @@
                libreadline-dev,
                llvm,
                zlib1g-dev (>= 1:1.2.3),
-               pkg-config,
+               pkgconf,
                pkg-kde-tools,
                python3-dev,
                rustc (>= 1.41),
                tzdata,
                zip
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/gnome-team/mozjs/tree/debian/115/master
 Vcs-Git: https://salsa.debian.org/gnome-team/mozjs.git -b debian/115/master
 Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey
 
-Package: libmozjs-115-0
+Package: libmozjs-115-0t64
+Provides: ${t64:Provides}
+Replaces: libmozjs-115-0
+Breaks: libmozjs-115-0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, tzdata
@@ -42,7 +45,7 @@
 Package: libmozjs-115-dev
 Architecture: any
 Section: libdevel
-Depends: libmozjs-115-0 (= ${binary:Version}),
+Depends: libmozjs-115-0t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: SpiderMonkey JavaScript library - development headers

## mozjs115 115.17.0

=== debian/changelog ===
mozjs115 (115.17.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 29 Oct 2024 17:38:57 +0100

## mozjs115 115.18.0

=== debian/changelog ===
mozjs115 (115.18.0-1) unstable; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 26 Nov 2024 16:28:47 -0500

## mozjs115 115.19.0

=== debian/changelog ===
mozjs115 (115.19.0-1) unstable; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release

  [ Simon McVittie ]
  * Add patches from mozilla-central partially fixing build with python3.13
  * d/control, d/rules, d/clean: Use python3-legacy-cgi (Closes: #1084631)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 08 Jan 2025 13:29:00 -0900

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 # like zsh
 export SHELL = /bin/sh
 export PYTHON3 = python3
+export PYTHONPATH=$(CURDIR)/debian/site-packages
 # Please tell us what you're thinking...
 export MOZ_CONFIGURE_TRACE = yes
 
@@ -136,6 +137,8 @@
 endif
 
 override_dh_auto_configure:
+	mkdir -p $(CURDIR)/debian/site-packages
+	ln -fns /usr/lib/python3/dist-packages/cgi* $(CURDIR)/debian/site-packages/
 	mkdir -p $(BUILDDIR)/dist/cppunittests
 	cd $(BUILDDIR); \
 	if env \

## mozjs115 115.20.0

=== debian/changelog ===
mozjs115 (115.20.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2025-1012 Use-after-free during concurrent delazification

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 04 Feb 2025 18:50:57 -0500

## mozjs115 115.21.0

=== testing/web-platform/tests/tools/third_party/funcsigs/Makefile ===
SHELL := /bin/bash

deps:
	pip install --upgrade \
	            -r requirements/development.txt \
	            -r requirements/production.txt

sdist:
	python setup.py sdist
	python setup.py bdist_wheel

register:
	python setup.py register
	python setup.py sdist upload
	python setup.py bdist_wheel upload

site:
	cd docs; make html

test:
	coverage run setup.py test

unittest:
	coverage run -m unittest discover

lint:
	flake8 --exit-zero funcsigs tests

coverage:
	coverage report --show-missing

clean:
	python setup.py clean --all
	find . -type f -name "*.pyc" -exec rm '{}' +
	find . -type d -name "__pycache__" -exec rmdir '{}' +
	rm -rf *.egg-info .coverage
	cd docs; make clean

docs: site

=== debian/changelog ===
mozjs115 (115.21.0-1) unstable; urgency=high

  * New upstream release
    - CVE-2025-1933 JIT corruption of WASM i386 return value on 64-bit CPUs
    - CVE-2025-1937 Memory safety bugs

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 04 Mar 2025 10:07:49 -0500

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
                pkgconf,
                pkg-kde-tools,
                python3-dev,
+               python3-legacy-cgi,
                rustc (>= 1.41),
                tzdata,
                zip

=== debian/rules ===
--- 
+++ 
@@ -177,9 +177,6 @@
 execute_after_dh_fixperms:
 	chmod a-x $(CURDIR)/debian/$(LIBNAME)-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/mozjs-$(MOZJS_VERSION).pc
 
-override_dh_gnome:
-	dh_gnome --no-gnome-versions
-
 override_dh_auto_test:
 	@:
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
